#include "datos.h"

Datos::Datos()
{
	ifstream fic("opc.bin", ios::in | ios::binary);
	
	if(!fic.is_open())
	{
		tiempoPartida = 30;
		nivel = 3;
		subidaNivel = 3;
		bajadaNivel = 2;
	}
	else
	{
		fic.read((char*)&tiempoPartida, sizeof(int));
		fic.read((char*)&nivel, sizeof(int));
		fic.read((char*)&subidaNivel, sizeof(int));
		fic.read((char*)&bajadaNivel, sizeof(int));
	
		fic.close();
	}
}

Datos::~Datos()
{
	ofstream fic("opc.bin", ios::out | ios::binary);
	
	fic.write((char*)&tiempoPartida, sizeof(int));
	fic.write((char*)&nivel, sizeof(int));
	fic.write((char*)&subidaNivel, sizeof(int));
	fic.write((char*)&bajadaNivel, sizeof(int));
	
	fic.close();
}

void
Datos::ejecutar()
{
	string opcion;
	int opcMenu, valor;
	
	do
	{
		cout << endl;
		cout << "  .|''''|, "<< endl;
		cout << "  ||    ||                ''                               " << endl;
		cout << "  ||    || '||''|, .|'',  ||  .|''|, `||''|,  .|''|, ('''' " << endl;
		cout << "  ||    ||  ||  || ||     ||  ||  ||  ||  ||  ||..||  `'') " << endl;
		cout << "  `|....|'  ||..|' `|..' .||. `|..|' .||  ||. `|...  `...' " << endl;
		cout << "            ||                                             " << endl;
		cout << "           .||                                             " << endl;
		cout << endl;
		cout << "  1. Tiempo de juego: " << tiempoPartida << endl;
		cout << "  2. Nivel inicial: " << nivel << endl;
		cout << "  3. Racha para subir de nivel: " << subidaNivel << endl;
		cout << "  4. Fallos para bajar de nivel: " << bajadaNivel << endl;
		cout << "  5. Cargar valores por defecto " << endl;
		cout << "  6. Volver al menú principal " << endl;
		cout << endl << "Introduce una opción para modificarla: ";
		getline(cin,opcion);
		opcMenu = atoi(opcion.c_str());
		switch(opcMenu)
		{
			case 1: 
				do
				{
					cout << "Introduzca nuevo valor para el tiempo de juego: ";
					getline(cin, opcion);
					valor = atoi(opcion.c_str());
					if(valor > 0)
						tiempoPartida = valor;
					else
					{
						cout << "Introduzca un valor mayor a 0" << endl;
						valor = 0;
					}
				}
				while(valor == 0);
				break;
			case 2:
				do
				{
					cout << "Introduzca nuevo valor para el nivel inicial: ";
					getline(cin, opcion);
					valor = atoi(opcion.c_str());
					if(valor > 0 && valor <= 9)
						nivel = valor;
					else
					{
						cout << "El nivel tiene un valor entre 1 y 9" << endl;
						valor = 0;
					}
				}
				while(valor == 0);
				break;
			case 3:
				do
				{
					cout << "Introduzca nuevo valor para los aciertos necesarios para subir de nivel: " ;
					getline(cin, opcion);
					valor = atoi(opcion.c_str());
					if(valor > 0)
						subidaNivel = valor;
					else
					{
						cout << "Introduzca un valor mayor a 0" << endl;
						valor = 0;
					}
				}
				while(valor == 0);
				break;
			case 4:
				do
				{
					cout << "Introduzca nuevo valor para los fallos necesarios para bajar de nivel: " ;
					getline(cin, opcion);
					valor = atoi(opcion.c_str());
					if(valor > 0)
						bajadaNivel = valor;
					else
					{
						cout << "Introduzca un valor mayor a 0" << endl;
						valor = 0;
					}
				}
				while(valor == 0);
				break;
			case 5:
				tiempoPartida = 30;
				nivel = 3;
				subidaNivel = 3;
				bajadaNivel = 2;
				
				break;
		}
		system("clear");
	}
	while(opcMenu != 6);
}

bool 
Datos::valoresPorDefecto()
{	
	return ((nivel <= 3) && (tiempoPartida <=30) && (subidaNivel >= 3) && (bajadaNivel <= 2));
}
