#include "menu.h"

using namespace std;

Menu::Menu()
{
	posicionTop posicion;
	ifstream fic("data.bin", ios::in | ios::binary);

	if(!fic.is_open())
	{
		cout << "No existe fichero de puntuaciones. Creando uno nuevo..." << endl;
		for(int i=0;i<3;i++)
			posicion.nick[i] = 'a';
		posicion.puntuacion = 50;
		posiciones.push_back(posicion);
		for(int i=0;i<3;i++)
			posicion.nick[i] = 'b';
		posicion.puntuacion = 40;
		posiciones.push_back(posicion);
		for(int i=0;i<3;i++)
			posicion.nick[i] = 'c';
		posicion.puntuacion = 30;
		posiciones.push_back(posicion);
		for(int i=0;i<3;i++)
			posicion.nick[i] = 'd';
		posicion.puntuacion = 20;
		posiciones.push_back(posicion);
		for(int i=0;i<3;i++)
			posicion.nick[i] = 'e';
		posicion.puntuacion = 10;
		posiciones.push_back(posicion);
	}
	else
	{
		fic.read((char*)&posicion, sizeof(posicionTop));
		while(!fic.eof())
		{
			posiciones.push_back(posicion);
			fic.read((char*)&posicion, sizeof(posicionTop));
		}
		fic.close();
	}
}

Menu::~Menu()
{
	ofstream fic("data.bin", ios::out | ios::binary);
	
	if(!fic)
		cout << "Se ha producido un error en la apertura del fichero de puntuaciones" << endl;
	else
	{
		for(unsigned int i=0;i<posiciones.size();i++)
			fic.write((char*)&posiciones[i], sizeof(posicionTop));

		fic.close();
	}
}

bool ordenar(posicionTop a,posicionTop b)
{
	return a.puntuacion > b.puntuacion;
}

int
Menu::ejecutar()
{
	int retorno = 0, puntuacion = 0;
	string opcion, iniciales;
	posicionTop pos;
	
	tutorial.ejecutar();
	
	do
	{
		opcion="";
		do 
		{
			system("clear");
			cout << endl;
			cout << "+----------------------------------------------------------------------------------------+" << endl;
			cout << "|                                                                                        |" << endl;
			cout << "|  _|      _|      _|_|_|_|      _|      _|      _|_|_|_|_|        _|_|        _|        |" << endl;
			cout << "|  _|_|  _|_|      _|            _|_|    _|          _|          _|    _|      _|        |" << endl;
			cout <<	"|  _|  _|  _|      _|_|_|        _|  _|  _|          _|          _|_|_|_|      _|        |" << endl;
			cout <<	"|  _|      _|      _|            _|    _|_|          _|          _|    _|      _|        |" << endl;
			cout <<	"|  _|      _|      _|_|_|_|      _|      _|          _|          _|    _|      _|_|_|_|  |" << endl;
			cout << "|                                                                                        |" << endl;
			cout << "+----------------------------------------------------------------------------------------+" << endl;
			cout << "|  1. Jugar                                                                              |" << endl;
			cout << "|  2. Opciones                                                                           |" << endl;
			cout << "|  3. Hall of Fame                                                                       |" << endl;
			cout << "|  4. Challenges                                                                         |" << endl;
			cout << "|  5. Reiniciar los Challenges                                                           |" << endl;
			cout << "|  6. Salir                                                                              |" << endl;
			cout << "+----------------------------------------------------------------------------------------+" << endl; 
			cout << endl;
			cout << "Introduzca una opción del menu: " ;
			getline(cin, opcion);
			retorno = atoi(opcion.c_str());
		}
		while(retorno < 1 || retorno > 6);
	
		switch(retorno)
		{
			case 1: 
			{	
				system("clear");
				cout << endl;
				puntuacion = juego.ejecutar(datos, challenges);
				if(puntuacion > posiciones[posiciones.size()-1].puntuacion)
				{
					cout << "¡Has entrado en el Hall of Fame! Enhorabuena" << endl;
					cout << "Introduce tus iniciales, ¡Máximo 3! Por eso del toque retro: " ;
					getline(cin, iniciales);
					pos.puntuacion = puntuacion;
					for(int i=0;i<3;i++)
						pos.nick[i] = iniciales[i];
					pos.nick[3] = '\0';
					posiciones.push_back(pos);
					sort(posiciones.begin(), posiciones.end(), ordenar);
					posiciones.pop_back();
					hallOfFame();
				}
				else
				{
					cout << "Pulsa Intro para continuar..." << endl;
					getline(cin, opcion);
					system("clear"); 
				}
				break;
			}
			case 2: system("clear"); datos.ejecutar(); break;
			case 3: hallOfFame(); break;
			case 4: system("clear"); challenges.mostrar() ; break;
			case 5: system("clear"); challenges.reset(); break;
			case 6: system("clear"); break;
			default: cout << "Opción sin código" << endl; break;
		}
	}	
	while(retorno!=6);
	
	return retorno;
}

void
Menu::hallOfFame()
{
	string cadena;
	
	system("clear");
	
	cout << endl;
	cout << "  __, _, ____,__,  __,    ____, ____,  ____,____,__, _,____, " << endl;
	cout << " (-|__| (-/_|(-|  (-|    (-/  \\(-|_,  (-|_,(-/_|(-|\\/|(-|_,  " << endl;
	cout << "  _|  |,_/  |,_|__,_|__,  _\\__/,_|     _|  _/  |,_| _|,_|__, " << endl;
	cout << " (     (     (    (      (     (      (   (     (     (      " << endl;
	cout << endl;
	cout << "------------------------------------------------------------" << endl;
	for(unsigned int i=0;i<posiciones.size();i++)
		cout << '\t' << '\t' << '\t' << i+1 <<"º "<< posiciones[i].nick << " " << posiciones[i].puntuacion << endl;
	cout << "------------------------------------------------------------" << endl;
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
	system("clear"); 
}
