#include "tutorial.h"

Tutorial::Tutorial()
{
}

Tutorial::~Tutorial()
{
}

void
Tutorial::ejecutar()
{
	string cadena;
	int opcion;
	
	do
	{
		cout << endl;
		cout << "   ___________________________________" << endl;
		cout << "  /                                   \\" << endl; 
		cout << "  |  ¡Hola! Soy tu amigo el Matemago  | " << endl; 
		cout << "  |  y seré tu guía para este juego   | " << endl;
		cout << "  |  buenísimo.                       | " << endl;
		cout << "  |                                   | " << endl;
		cout << "  |  Puedo ayudarte en lo siguiente:  | " << endl;
		cout << "  |  1. Mecánica                      | " << endl;
		cout << "  |  2. Puntuación                    | " << endl;
		cout << "  |  3. Información general           | " << endl;
		cout << "  |  4. Challenges                    | " << endl;
		cout << "  |  5. ¡A jugar!                     | " << endl;
		cout << "  \\___________________________________/" << endl;
		cout << "                                 /\\ " << endl;
		cout << "                              \\ c\") " << endl;                                                
		cout << "                               ;-/\\> " << endl;
		cout << "                                 ||  " << endl;
		cout << endl << "Introduce una opción del menú: " ;
		getline(cin, cadena);
		opcion = atoi(cadena.c_str());
		system("clear");
		switch(opcion)
		{
			case 1: mecanica(); break;
			case 2: puntuacion(); break;
			case 3: informacion(); break;
			case 4: challenges(); break;
			case 5: break;
		}
		system("clear");
	}
	while(opcion!=5);
}

void
Tutorial::mecanica()
{
	string cadena;
	
	cout << endl;
	cout << "   ____________________________________________________________" << endl;
	cout << "  /                                                            \\" << endl; 
	cout << "  |  Este juego está basado en el cálculo mental.              | " << endl; 
	cout << "  |                                                            | " << endl;
	cout << "  |  Una vez empieces a jugar, tendrás un límite de tiempo     | " << endl;
	cout << "  |  en el cual deberás de responder correctamente el máximo   | " << endl;
	cout << "  |  número de operaciones.                                    | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Antes de cada operación, hay información entre corchetes  | " << endl;
	cout << "  |  [Segundos/TiempoTotal|Aciertos|Nivel|Puntuación], que     | " << endl;
	cout << "  |  te servirá para situarte en todo momento de la partida.   | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  El juego está estructurado en niveles, a mayor nivel,     | " << endl;
	cout << "  |  mayor dificultad de las operaciones, y más operaciones    | " << endl;
	cout << "  |  distintas a realizar.                                     | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Para aumentar de nivel, tienes que responder una cantidad | " << endl;
	cout << "  |  de respuestas correctamente seguidas. Este valor es 3 por | " << endl;
	cout << "  |  defecto, pero es personalizable en el menú de opciones.   | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Para bajar de nivel, me temo que es más fácil, con        | " << endl;
	cout << "  |  resolver mal una cantidad de operaciones en un nivel,     | " << endl;
	cout << "  |  bajarás de nivel, hasta un mínimo de 1. ¡No es necesario  | " << endl;
	cout << "  |  que sean seguidas! Advertido quedas.                      | " << endl;
	cout << "  \\___________________________________________________________/" << endl;
	cout << "                                                          /\\ " << endl;
	cout << "                                                       \\ c\") " << endl;                                                
	cout << "                                                        ;-/\\> " << endl;
	cout << "                                                          ||  " << endl;   
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
}

void
Tutorial::puntuacion()
{
	string cadena;
	
	cout << endl;
	cout << "   ____________________________________________________________" << endl;
	cout << "  /                                                            \\" << endl; 
	cout << "  |  La puntuación de este juego se basa en el nivel en el     | " << endl; 
	cout << "  |  que te encuentras, a más nivel, más puntos por operación  | " << endl;
	cout << "  |  resulta correctamente. En caso de fallo, no se penaliza   | " << endl;
	cout << "  |  el error, simplemente no suma puntos.                     | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Los puntos son calculado como tu nivel más uno, y         | " << endl;
	cout << "  |  dividiendo el resultado entre dos, redondeando hacia      | " << endl;
	cout << "  |  abajo.                                                    | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Al finalizar la partida, si tu puntuación está entre      | " << endl;
	cout << "  |  las cinco primeras de la lista del Hall of Fame, se       | " << endl;
	cout << "  |  te solicitarán tus iniciales para añadirlas y así         | " << endl;
	cout << "  |  dejar constancia de tu hazaña.                            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  El Hall of Fame se almacena en un fichero de datos        | " << endl;
	cout << "  |  binario al finalizar la ejecución, para así poder         | " << endl;
	cout << "  |  almacenar toda la información, y que no se pierda. ¡Tu    | " << endl;
	cout << "  |  puntuación quedará inmortalizada para siempre!            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  \\___________________________________________________________/" << endl;
	cout << "                                                          /\\ " << endl;
	cout << "                                                       \\ c\") " << endl;                                                
	cout << "                                                        ;-/\\> " << endl;
	cout << "                                                          ||  " << endl;   
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
}

void
Tutorial::informacion()
{
	string cadena;
	
	cout << endl;
	cout << "   ____________________________________________________________" << endl;
	cout << "  /                                                            \\" << endl; 
	cout << "  |  En este apartado, hablaré un poco de todo.                | " << endl; 
	cout << "  |                                                            | " << endl;
	cout << "  |  El juego está basado en menús de texto. Cada opción       | " << endl;
	cout << "  |  tiene un número asociado, que escribiremos y a            | " << endl;
	cout << "  |  continuación pulsaremos Intro para validar dicha opción.  | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  En el menú de opciones podemos cambiar ciertos valores    | " << endl;
	cout << "  |  para conseguir un juego más ajustado a nuestro nivel de   | " << endl;
	cout << "  |  juego. Las opciones también se guardan entre ejecuciones, | " << endl;
	cout << "  |  por lo que no perderemos nuestros cambios.                | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Retomando el tema del juego, cada nivel nos especifica    | " << endl;
	cout << "  |  qué operaciones nos pueden aparecer. Hasta nivel 3 sólo   | " << endl;
	cout << "  |  sumas, del 3 al 5, también restas, del nivel 5 al 7,      | " << endl;
	cout << "  |  se añaden las multiplicaciones, y a partir del nivel 7    | " << endl;
	cout << "  |  las divisiones nos acompañarán.                           | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Los valores máximos de los operandos son de nivel*5, y    | " << endl;
	cout << "  |  el resultado de la operación, en caso de la suma no       | " << endl;
	cout << "  |  superará el nivel*10, y en caso de la multiplicación, el  | " << endl;
	cout << "  |  nivel*5. Los resultados nunca serán negativos.            | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  \\___________________________________________________________/" << endl;
	cout << "                                                          /\\ " << endl;
	cout << "                                                       \\ c\") " << endl;                                                
	cout << "                                                        ;-/\\> " << endl;
	cout << "                                                          ||  " << endl;   
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
}

void
Tutorial::challenges()
{
	string cadena;
	
	cout << endl;
	cout << "   ____________________________________________________________" << endl;
	cout << "  /                                                            \\" << endl; 
	cout << "  |  ¡¡ CHALLENGES !!                                          | " << endl; 
	cout << "  |                                                            | " << endl;
	cout << "  |  Retos para los más valientes con habilidades para las     | " << endl;
	cout << "  |  matemáticas.                                              | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  En su apartado en el menú principal podemos ver los       | " << endl;
	cout << "  |  distintos Challenges disponibles, cada uno con un nivel   | " << endl;
	cout << "  |  de dificultad asociado en un lenguaje muy informático.    | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Al terminar cada partida, se comprobará si se ha          | " << endl;
	cout << "  |  conseguido alguno de los Challenges disponibles.          | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Los Challenges se guardan en un fichero entre ejecución   | " << endl;
	cout << "  |  y ejecución, lo que nos permite mantener los Challenges   | " << endl;
	cout << "  |  que hayamos obtenido.                                     | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  Si hemos conseguido todos (aunque es complicado), en el   | " << endl;
	cout << "  |  menú principal hay una opción para reiniciar la lista,    | " << endl;
	cout << "  |  para intentar conseguirlos otra vez.                      | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  |  ¡Una idea revolucionaria nunca vista!                     | " << endl;
	cout << "  |                                                            | " << endl;
	cout << "  \\___________________________________________________________/" << endl;
	cout << "                                                          /\\ " << endl;
	cout << "                                                       \\ c\") " << endl;                                                
	cout << "                                                        ;-/\\> " << endl;
	cout << "                                                          ||  " << endl;   
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
}